dissect(value,i,j,bottom,condense,heading,left,length,right,width,argv,outname,argc,outfile,top)
    int     value,
	    i,
	    j,
	    bottom,
	    condense,
	    heading,
	    left,
	    length,
	    right,
	    top,
	    argc,
	    outfile,
	    width;
    char   *argv[],
	   *outname[];
    {
    /**************************************************************************/
    /*									      */
    /* Dissect keyword parameters					      */
    /*									      */
    /**************************************************************************/
    if (argc > 1)
	{
	for(i=1;i<argc+1;i++)
	    {
	    /******************************************************************/
	    /*								      */
	    /* If a parameter starts with a '/' it might be valid             */
	    /*								      */
	    /******************************************************************/
	    if (argv[i][0] = '/')
		{
		/**************************************************************/
		/*							      */
		/* Change page's bottom margin                                */
		/*							      */
		/**************************************************************/
		if (toupper(argv[i][1]) == 'B')
		    {
		    value = 0;
		    for(j=2;j<strlen(argv[i]);j++)
			{
			if (j == 5)
			    {
			    puts("\n");
			    puts("/B value too large\n");
			    exit(0);
			    }
			if (!isdigit(argv[i][j]))
			    {
			    puts("\n");
			    puts("Invalid /B value\n");
			    exit(0);
			    }
			value = (value * 10) + (argv[i][j] - '0');
			}
		    bottom = value;
		    }
		/**************************************************************/
		/*							      */
		/* Condense mode requested				      */
		/*							      */
		/**************************************************************/
		if (toupper(argv[i][1]) == 'C')
		    {
		    condense = 1;
		    }
		/**************************************************************/
		/*							      */
		/* Print is to be directed to a file (or device) selected     */
		/* by the user						      */
		/*							      */
		/**************************************************************/
		if (toupper(argv[i][1]) == 'F')
		    {
		    /**********************************************************/
		    /*							      */
		    /* Check for wildcard characters in filename	      */
		    /*							      */
		    /**********************************************************/
		    for(j=2;j<strlen(argv[i]);j++)
			{
			if ((argv[i][j] == '*') || (argv[i][j] == '?'))
			    {
			    puts("\n");
			    puts("Sorry ... wildcards not catered for.\n");
			    exit(0);
			    }
			outname[j-2] = argv[i][j];
			}
		    outname[j-2] = '\0';
		    /**********************************************************/
		    /*							      */
		    /* Ceck for fatal error of having input and output	      */
		    /* filenames the same				      */
		    /*							      */
		    /**********************************************************/
		    if (strcmp(argv[1],outname) == 0)
			{
			puts("\nInput filename and output filename");
			puts(" cannot be the same.\n");
			exit(1);
			}
		    /**********************************************************/
		    /*							      */
		    /* Attempt to open file to accept output		      */
		    /*							      */
		    /**********************************************************/
		    if ((outfile = open(outname,1)) == -1)
			{
			if ((outfile = creat(outname)) == -1)
			    {
			    printf("\nCannot access file %s\n",outname);
			    exit(1);
			    }
			}
		    fclose(outfile);
		    }
		/**************************************************************/
		/*							      */
		/*  If present, page heading not required		      */
		/*							      */
		/**************************************************************/
		if (toupper(argv[i][1]) == 'H')
		    {
		    heading = 0;
		    }
		/**************************************************************/
		/*							      */
		/* Change page's left margin default                          */
		/*							      */
		/**************************************************************/
		if (toupper(argv[i][1]) == 'L')
		    {
		    value = 0;
		    for(j=2;j<strlen(argv[i]);j++)
			{
			if (j == 5)
			    {
			    puts("\n");
			    puts("/L value too large\n");
			    exit(0);
			    }
			if (!isdigit(argv[i][j]))
			    {
			    puts("\n");
			    puts("Invalid /L value\n");
			    exit(0);
			    }
			value = (value * 10) + (argv[i][j] - '0');
			}
		    left = value;
		    }
		/**************************************************************/
		/*							      */
		/* Change page's length                                       */
		/*							      */
		/**************************************************************/
		if (toupper(argv[i][1]) == 'P')
		    {
		    value = 0;
		    for(j=2;j<strlen(argv[i]);j++)
			{
			if (j == 5)
			    {
			    puts("\n");
			    puts("/P value too large\n");
			    exit(0);
			    }
			if (!isdigit(argv[i][j]))
			    {
			    puts("\n");
			    puts("Invalid /P value\n");
			    exit(0);
			    }
			value = (value * 10) + (argv[i][j] - '0');
			}
		    length = value;
		    }
		/**************************************************************/
		/*							      */
		/* Change page's right margin                                 */
		/*							      */
		/**************************************************************/
		if (toupper(argv[i][1]) == 'R')
		    {
		    value = 0;
		    for(j=2;j<strlen(argv[i]);j++)
			{
			if (j == 5)
			    {
			    puts("\n");
			    puts("/R value too large\n");
			    exit(0);
			    }
			if (!isdigit(argv[i][j]))
			    {
			    puts("\n");
			    puts("Invalid /R value\n");
			    exit(0);
			    }
			value = (value * 10) + (argv[i][j] - '0');
			}
		    right = value;
		    }
		/**************************************************************/
		/*							      */
		/* Change page's top margin                                   */
		/*							      */
		/**************************************************************/
		if (toupper(argv[i][1]) == 'T')
		    {
		    value = 0;
		    for(j=2;j<strlen(argv[i]);j++)
			{
			if (j == 5)
			    {
			    puts("\n");
			    puts("/T value too large\n");
			    exit(0);
			    }
			if (!isdigit(argv[i][j]))
			    {
			    puts("\n");
			    puts("Invalid /T value\n");
			    exit(0);
			    }
			value = (value * 10) + (argv[i][j] - '0');
			}
		    top = value;
		    }
		/**************************************************************/
		/*							      */
		/* Change page's width                                        */
		/*							      */
		/**************************************************************/
		if (toupper(argv[i][1]) == 'W')
		    {
		    value = 0;
		    for(j=2;j<strlen(argv[i]);j++)
			{
			if (j == 5)
			    {
			    puts("\n");
			    puts("/W value too large\n");
			    exit(0);
			    }
			if (!isdigit(argv[i][j]))
			    {
			    puts("\n");
			    puts("Invalid /W value\n");
			    exit(0);
			    }
			value = (value * 10) + (argv[i][j] - '0');
			}
		    width = value;
		    }
		}
	    }
	}
    }
